//-----------------------------------------------------------------------------
//
//	This program is free software; you can redistribute it and/or
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//-----------------------------------------------------------------------------

// bootloader client for AVR USB DFU
// Javier Almansa Sobrino (javieralso@gmail.com)

#include "bootAT90USB1287.h"
#include "bootUsb.h"
#include "hex.h"
#include "bootFunc.h"


int main (int argv, char **argc) {

  FILE *fp;
  usb_dev_handle *descriptor = NULL;

  if (argv < 2) {
    printf ("Enter the file name you want to load\n");
    return -1;
  } else {
    if ((fp = fopen (argc[1], "r")) == NULL) {
      printf ("File \"%s\" not found\n", argc[1]);
      return -1;
    }
  }
  
  descriptor = deviceOpen ();
  
  int a;
  
  if (descriptor != NULL) {
    if (eraseWhole (descriptor) == 0) {
      if ((a=writeProg (fp, descriptor)) == 0) {
	printf ("Device programmed\n");
	startApp ((unsigned short) 0x0000, descriptor);
	printf ("Starting firmware on default address (0x0000 page 0)\n");
      } else {
	printf ("Program failed: %i\n",a );
      }
    } else {
      printf ("Erase failed\n");
    }
  } else {
    printf ("Error: Can't open USB port\n");
  }
  fclose (fp);
  return 0;
}


