//-----------------------------------------------------------------------------
//
//	This program is free software; you can redistribute it and/or
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//-----------------------------------------------------------------------------

#ifndef _USBTASK_H
#define _PK2TASK_H

#include	<usb.h>
#include "bootAT90USB1287.h"

#define	CONFIG_HID		1	// Use HID for pickit configuration
#define	CONFIG_VENDOR	2	// Vendor specific configuration

#define VENDOR_ID 0x03EB
#define PRODUCT_ID 0x2FFB

#define	reqLen	32

//typedef unsigned char byte;

typedef struct {

  unsigned int bmRequestType;
  unsigned int bRequest;
  unsigned int wValue;
  unsigned int wIndex;
  unsigned int wLength;

} request;

extern usb_dev_handle *deviceHandle;

//typedef byte unsigned char;

extern int	boot_interface;
extern int	boot2mode;
extern int	usbdebug;

/* Send data over usb */
void sendUSB(usb_dev_handle *d, const char *src, int len);

/* Read data from usb */
void recvUSB(usb_dev_handle *d, int len, byte *dest);

/* Open the pickit as a usb device.  Aborts on errors. */
usb_dev_handle *deviceOpen(void);

int usbRequest (usb_dev_handle *d, request r, byte *data);

#endif
